; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 714
WINDOWHEIGHT = 474
twists	     = 5
FLOAT3D struct
	x	REAL4 ?
	y	REAL4 ?
	z	REAL4 ?
FLOAT3D ends
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	num:DWORD
local	spost:dword
local	_spost:dword
local	alphainc:dword
local	alpha:dword

        mov	hWin,rcx
        xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_TIMER
	je      wmTIMER
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
;----------------------------------------------
wmTIMER:; Rotate helix
	movd	xmm0,angle
	addss	xmm0,const2
	movd	angle,xmm0
	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,12,0
;-------------------------------------------------------
 	mov	edx,offset Texture1_Id
	invoke	glGenTextures,1
	invoke	glBindTexture,GL_TEXTURE_2D,Texture1_Id
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR

	invoke	glEnable, GL_TEXTURE_2D
	invoke	glShadeModel,GL_SMOOTH;smooth shading
	movd	xmm3,const0_5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;    
	cvtss2sd xmm0,const1
	invoke	glClearDepth;   
	invoke	glEnable,GL_DEPTH_TEST ;  
	invoke	glDepthFunc,GL_LESS
;     ()
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST
        mov	edx,offset global_ambient
	invoke glLightModelfv,GL_LIGHT_MODEL_AMBIENT
	mov	edx,offset global_ambient
	invoke glLightModelfv,GL_LIGHT_MODEL_AMBIENT
	mov	r8d,offset light0pos
	invoke glLightfv, GL_LIGHT0,GL_POSITION
	mov	r8d,offset global_ambient
	invoke glLightfv, GL_LIGHT0,GL_AMBIENT
	mov	r8d,offset light0diffuse
	invoke glLightfv, GL_LIGHT0,GL_DIFFUSE
	mov	r8d,offset light0specular
	invoke	glLightfv, GL_LIGHT0,GL_SPECULAR
	invoke	glEnable,GL_LIGHTING
	invoke	glEnable,GL_LIGHT0
	invoke	glMateriali,GL_FRONT,GL_SHININESS,128
	mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,zFar
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
        movd	xmm3,const0_5
	movss	xmm2,xmm3
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT;clear screen before drawing
        invoke	glLoadIdentity ; 
	; RenderToTexture
	invoke	glViewport,0,0,128,128
	invoke	ProcessHelix
	invoke	glBindTexture,GL_TEXTURE_2D,Texture1_Id
	invoke	glCopyTexImage2D,GL_TEXTURE_2D,0,GL_LUMINANCE,0,rdx,128,128,rdx
	movd	xmm3,const0_5
	movss	xmm2,xmm3
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;,0,0,0.5,0.5
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
	invoke	glViewport,0,0,WINDOWWIDTH,WINDOWHEIGHT
	; Draw
	invoke	ProcessHelix
;Draw Blur------------------------------------------------------
	mov	spost,ebx ; Starting Texture Coordinate Offset
	movd	xmm0,const0_2
	movd	alpha,xmm0 ; Starting Alpha Value
	cvtsi2ss xmm1,const25;times 
	divss	xmm0,xmm1; Fade Speed For Alpha Blending
	movd	alphainc,xmm0 ; alphainc=0.2/ Times To Render Blur
; Disable AutoTexture Coordinates
	invoke	glDisable,GL_TEXTURE_GEN_S 
	invoke	glDisable,GL_TEXTURE_GEN_T
	invoke	glEnable,GL_TEXTURE_2D
	invoke	glDisable,GL_DEPTH_TEST
	invoke	glBlendFunc,GL_SRC_ALPHA,GL_ONE
	invoke	glEnable,GL_BLEND
	invoke	glBindTexture,GL_TEXTURE_2D,Texture1_Id
; Switch To Ortho View
        invoke	glMatrixMode,GL_PROJECTION
	invoke	glPushMatrix
        invoke	glLoadIdentity
	xorps	xmm3,xmm3
	movq	xmm2,constd480
	movq	xmm1,constd640
	xorps	xmm0,xmm0
	invoke	glOrtho,,,,,constd_1,constd1; 0,640,480,0,-1,1
	invoke	glMatrixMode,GL_MODELVIEW
	invoke	glPushMatrix
	invoke	glLoadIdentity

	invoke	glBegin,GL_QUADS
	mov	num,ebx
@@:	movd	xmm0,const1
	subss	xmm0,spost ; 1 - spost
	movd	_spost,xmm0

	movd	xmm3,alpha
	movd	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glColor4f;,f1_0,f1_0,f1_0, ; Set The Alpha Value (Starts At 0.2)
	movd	xmm1,_spost
	movd	xmm0,spost
	invoke	glTexCoord2f	; Texture Coordinate	( 0, 1 )
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glVertex2f;,0,0				; First Vertex		( 0, 0 )
	movd	xmm1,spost
	movss	xmm0,xmm1
	invoke	glTexCoord2f;,spost,spost	; Texture Coordinate	( 0, 0 )
	movd	xmm1,const480
	xorps	xmm0,xmm0
	invoke	glVertex2f;,0,f480			; Second Vertex	( 0, 480 )
	movd	xmm1,spost
	movd	xmm0,_spost
	invoke	glTexCoord2f;,_spost,spost	; Texture Coordinate	( 1, 0 )
	movd	xmm1,const480
	movd	xmm0,const640
	invoke	glVertex2f;,f640,f480		; Third Vertex		( 640, 480 )
	movd	xmm1,_spost
	movss	xmm0,xmm1
	invoke	glTexCoord2f;,_spost,_spost	; Texture Coordinate	( 1, 1 )
	xorps	xmm1,xmm1
	movd	xmm0,const640
	invoke	glVertex2f;,f640,0			; Fourth Vertex		( 640,   0 )
	movd	xmm0,spost
	addss 	xmm0,BlurInc ; Gradually Increase spost (Zooming Closer To Texture Center)
	movd	spost,xmm0
	movd	xmm0,alpha
	subss	xmm0,alphainc ; Gradually Decrease alpha (Gradually Fading Image Out)
	movd	alpha,xmm0
	inc	num
	mov	eax,num
	cmp	eax,25;times
	jb	@b
	invoke glEnd	
; Return To Perspective View
	invoke	glMatrixMode,GL_PROJECTION
	invoke	glPopMatrix
	invoke	glMatrixMode,GL_MODELVIEW
	invoke	glPopMatrix
	
	invoke	glEnable,GL_DEPTH_TEST
	invoke	glDisable,GL_TEXTURE_2D
	invoke	glDisable,GL_BLEND
	invoke	glBindTexture,GL_TEXTURE_2D,0
;---------------------------------------------------------
        invoke  glFlush
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
ProcessHelix proc
local	x_:dword
local	y_:dword
local	z_:dword
local	phi:dword
local	theta:dword
local	v0:dword
local	u0:dword
local	u:dword
local	r:dword
local	angle_div:dword
local	length_:dword
local	phi_int:dword
local	theta_int:DWORD
local	v10:FLOAT3D
local	v20:FLOAT3D
local	temp:dword
	
	mov	phi_int,ebx;0
	movd	xmm0,const1_5 ; Radius Of Twist
	movd	r,xmm0
	mov	phi,ebx
	movd	xmm0,angle
	divss	xmm0,const2
	movd	angle_div,xmm0

	invoke	glLoadIdentity
	xorps	xmm3,xmm3
	movq	xmm2,eyez
	movq	xmm1,constd5
	xorps	xmm0,xmm0
	invoke	gluLookAt,,,,,rbx,rbx,rbx,constd1,rbx ; 0,5,50,0,0,0,0,1,0 -> Eye Position (0,5,50) Center Of Scene (0,0,0), Up On Y Axis
	invoke	glPushMatrix

	movd	xmm2,HelixDistance
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;,0,0, ; Translate 50 Units Into The Screen
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movd	xmm1,const1
	movd	xmm0,angle_div
	invoke	glRotatef;,,1,0,0 ; Rotate By angle/2 On The X-Axis
	movd	xmm0,angle
	divss	xmm0,const3
	movd	angle_div,xmm0

	xorps	xmm3,xmm3
	movd	xmm2,const1
	xorps	xmm1,xmm1
	movd	xmm0,angle_div
	invoke	glRotatef;,angle_div,0,1,0 ; Rotate By angle/3 On The Y-Axis
	mov	r8d,offset glfMaterialColor
	invoke	glMaterialfv,GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE
	mov	r8d,offset specular
	invoke	glMaterialfv,GL_FRONT_AND_BACK,GL_SPECULAR
	invoke	glBegin,GL_QUADS
;	.while phi_int <= 360 ; 360 Degrees In Steps Of 20
@@:	mov	theta_int,ebx
	mov	theta,ebx
@0:		;.while theta_int <= (360*twists) ; 360 Degrees * Number Of Twists In Steps Of 20
; *** 1 ***
	movd	xmm0,phi ; Calculate Angles Of First Point
	divss	xmm0,const180
	mulss	xmm0,constPi
	movd	v0,xmm0 ; v0=(phi/180.0f*3.142f)
; Calculate x Position (1st Point)
	invoke	cosf
	addss	xmm0,const2
	movd	temp,xmm0

	movd	xmm0,theta
	divss	xmm0,const180
	mulss	xmm0,constPi
	movd	u0,xmm0 ; u0=(theta/180.0f*3.142f)
	invoke	cosf
	mulss	xmm0,r
	mulss	xmm0,temp ; leaves 2.0f+cos(v0) on fpu stack !
	movd	vertex1.x,xmm0 ; x=(cos(u0)*(2.0f+cos(v0) ))*r

	movd	xmm0,u0 ; Calculate y Position (1st Point)
	invoke	sinf
	mulss	xmm0,r
	mulss	xmm0,temp ; 2.0f+cos(v0) is still on fpu stack !
	movd	vertex1.y,xmm0  ; y=(sin(u0)*(2.0f+cos(v0) ))*r

	movd	xmm0,v0 ; Calculate z Position (1st Point)
	invoke	sinf
	movd	temp,xmm0
	movd	xmm0,u0
	subss	xmm0,const2Pi
	addss	xmm0,temp
	mulss	xmm0,r
	movd	vertex1.z,xmm0 ; z=(( u-(2.0f*3.142f)) + sin(v0) ) * r			
; *** 2 ***
	movd	xmm0,theta
	addss	xmm0,const20
	divss	xmm0,const180
	mulss	xmm0,constPi
	movd	u,xmm0

	movd	xmm0,v0
	invoke	cosf
	addss	xmm0,const2
	movd	temp,xmm0
	movd	xmm0,u
	invoke	cosf
	mulss	xmm0,r
	mulss	xmm0,temp
	movd	vertex2.x,xmm0
; Calculate Normals
	movd	xmm1,vertex1.x
	subss	xmm1,xmm0;vertex2.x
	movd	v10.x,xmm1 ; Vector 1.x=Vertex[0].x-Vertex[1].x
;--------------------------------------------------
	movd	xmm0,u
	invoke	sinf
	mulss	xmm0,r
	mulss	xmm0,temp
	movd	vertex2.y,xmm0
; Calculate Normals
	movd	xmm1,vertex1.y
	subss	xmm1,xmm0;vertex2.y
	movd	v10.y,xmm1 ; Vector 1.y=Vertex[0].y-Vertex[1].y
;------------------------------------------------------
	movd	xmm0,v0
	invoke	sinf
	movd	temp,xmm0
	movd	xmm0,u
	subss	xmm0,const2Pi
	addss	xmm0,temp
	mulss	xmm0,r
	movd	vertex2.z,xmm0
; Calculate Normals
	movd	xmm1,vertex1.z
	subss	xmm1,xmm0;vertex2.z
	movd	v10.z,xmm1 ; Vector 1.z=Vertex[0].y-Vertex[1].z
; *** 3 ***
	movd	xmm0,phi
	addss	xmm0,const20
	divss	xmm0,const180
	mulss	xmm0,constPi
	movd	v0,xmm0
	invoke	cosf
	addss	xmm0,const2
	movd	temp,xmm0
	movd	xmm0,u
	invoke	cosf
	mulss	xmm0,r
	mulss	xmm0,temp
	movd	vertex3.x,xmm0
; Calculate Normals
	movd	xmm1,vertex2.x
	subss	xmm1,xmm0;vertex3.x
	movd	v20.x,xmm1 ; Vector 2.x=Vertex[0].x-Vertex[1].x
;-----------------------------------------------------------------
	movd	xmm0,u
	invoke	sinf
	mulss	xmm0,r
	mulss	xmm0,temp
	movd	vertex3.y,xmm0
; Calculate Normals
	movd	xmm1,vertex2.y
	subss	xmm1,xmm0;vertex3.y
	movd	v20.y,xmm1 ; Vector 2.y=Vertex[0].y-Vertex[1].y
;-------------------------------------------------------
	movd	xmm0,v0
	invoke	sinf
	movd	temp,xmm0
	movd	xmm0,u
	subss	xmm0,const2Pi
	addss	xmm0,temp
	mulss	xmm0,r
	movd	vertex3.z,xmm0
; Calculate Normals
	movd	xmm1,vertex2.z
	subss	xmm1,xmm0;vertex3.z
	movd	v20.z,xmm1 ; Vector 2.z=Vertex[0].z-Vertex[1].z
; *** 4 ***
	movd	xmm0,v0
	invoke	cosf
	addss	xmm0,const2
	movd	temp,xmm0
	movd	xmm0,u0
	invoke	cosf
	mulss	xmm0,r
	mulss	xmm0,temp
	movd	vertex4.x,xmm0

	movd	xmm0,u0
	invoke	sinf
	mulss	xmm0,r
	mulss	xmm0,temp
	movd	vertex4.y,xmm0

	movd	xmm0,v0
	invoke	sinf
	movd	temp,xmm0
	movd	xmm0,u0
	subss	xmm0,const2Pi
	addss	xmm0,temp
	mulss	xmm0,r
	movd	vertex4.z,xmm0
			
	movd	xmm3,v10.z ; Compute The Cross Product To Give Us A Surface Normal
	mulss	xmm3,v20.y
	movd	xmm2,v10.y
	mulss	xmm2,v20.z
	subss	xmm2,xmm3;normal.x
	movd	normal.x,xmm2 ; Cross Product For Y - Z
; Normalize The Vectors
; Calculates The Length Of The Vector
	mulss	xmm2,xmm2;normal.x
			
	movd	xmm3,v10.x
	mulss	xmm3,v20.z
	movd	xmm1,v10.z
	mulss	xmm1,v20.x
	subss	xmm1,xmm3;normal.y
	movd	normal.y,xmm1 ; Cross Product For X - Z
	mulss	xmm1,xmm1;normal.y

	movd	xmm3,v10.y
	mulss	xmm3,v20.x
	movd	xmm0,v10.x
	mulss	xmm0,v20.y
	subss	xmm0,xmm3;normal.z
	movd	normal.z,xmm0 ; Cross Product For X - Y

	mulss	xmm0,xmm0;normal.z^2
	addss	xmm0,xmm1;normal.z^2+normal.y^2
	addss	xmm0,xmm2;normal.z^2+normal.y^2+normal.x^2
	sqrtss	xmm3,xmm0
	movd	length_,xmm3

	movd	xmm0,normal.x
	divss	xmm0,xmm3;length_
	movd	normal.x,xmm0
	movd	xmm1,normal.y
	divss	xmm1,xmm3;length_
	movd	normal.y,xmm1
	movd	xmm2,normal.z
	divss	xmm2,xmm3;length_
	movd	normal.z,xmm2

	invoke	glNormal3f;,normal.x,normal.y,normal.z
	movd	xmm2,vertex1.z
	movd	xmm1,vertex1.y		
	movd	xmm0,vertex1.x		
	invoke glVertex3f;,vertex1.x,vertex1.y,vertex1.z
	movd	xmm2,vertex2.z		
	movd	xmm1,vertex2.y		
	movd	xmm0,vertex2.x		
	invoke glVertex3f;,vertex2.x,vertex2.y,vertex2.z
	movd	xmm2,vertex3.z		
	movd	xmm1,vertex3.y		
	movd	xmm0,vertex3.x		
	invoke glVertex3f;,vertex3.x,vertex3.y,vertex3.z
	movd	xmm2,vertex4.z		
	movd	xmm1,vertex4.y		
	movd	xmm0,vertex4.x
	invoke glVertex3f;,vertex4.x,vertex4.y,vertex4.z
	movd	xmm0,theta
	addss 	xmm0,const20
	movd	theta,xmm0
	add	theta_int,20
	cmp	theta_int,(360*twists) ; 360 Degrees * Number Of Twists In Steps Of 20
	jbe	@0;.endw
	movd	xmm0,phi
	addss	xmm0,const20
	movd	phi,xmm0
	add	phi_int,20
	cmp	phi_int,360
	jbe	@b
	invoke	glEnd
	invoke	glPopMatrix
	leave
	ret
ProcessHelix endp

;---------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson #36: Radial Blur & Rendering To A Texture",0
FileName	db "br_Rabbit3.cur",0
; Blur
global_ambient	dd 	0.2, 0.2, 0.2, 1.0
light0pos	dd 	0,   5.0,10.0, 1.0
light0diffuse	dd 	0.3, 0.3, 0.3, 1.0
light0specular	dd 	0.8, 0.8, 0.8, 1.0
glfMaterialColor dd 	0.4, 0.2, 0.8, 1.0
specular	dd 	1.0, 1.0, 1.0, 1.0
; float constants
BlurInc		dd 0.02
const0_2	dd 0.2
const0_5	dd 0.5
const1		dd 1.0
const1_5	dd 1.5
const2		dd 2.0
const3		dd 3.0
constPi		dd 3.142
const2Pi	dd 6.284
const20		dd 20.0
const25		dd 25.0
HelixDistance	dd -50.0
const180	dd 180.0
const480	dd 480.0
const640	dd 640.0
;double----------------------------
constd0_1	dq 0.1
constd_1	dq -1.0
constd1		dq 1.0
constd5		dq 5.0
constd45	dq 45.0
eyez		dq 50.0
constd480	dq 480.0
constd640	dq 640.0
zFar		dq 2000.0
; Blur
Texture1_Id	dq ?
; Helix
vertex1		FLOAT3D		<?>
vertex2		FLOAT3D		<?>
vertex3		FLOAT3D		<?>
vertex4		FLOAT3D		<?>
normal		FLOAT3D		<?>
angle		dd ?
end